/*  ga_aux_prot.h */
/* 	Copyright 2004 Oswaldo Morizaki */

/* 	This file is part of ga-nn-ag.

    ga-nn is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    ga-nn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ga-nn; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


extern int coin_toss(int seed);
extern int toss(float prob, int seed);
extern int dice_toss(int seed, int partition);
extern float rand_gen(int seed);
extern int roulette(int num, float *fitness);
extern int mate(int poblation, int **parents, float * fitness);
extern int region_gen(float **vertice);
extern int inner(float ** vertice, float *coord);
extern int inner_neuron(int num_neuron, struct neuron ** neuron_array, float **vertice, 
						int *inner_elem);
extern int near_neuron(int num_neuron, struct neuron **neuron_array, int * inner_elem);
extern int isolate_region(int num_neuron, struct neuron **neuron_array, int * inner_elem);
extern void * remove_neuron(int num_neuron, struct neuron **neuron_array, 
											int * inner_elem, int * new_num_neuron);
extern void * append_neuron(int num_neuron1, int num_neuron2, struct neuron ** parent1, 
											struct neuron ** parent2, int * inner_elem2, int * new_num_neuron);
extern int mutate_neuron(struct neuron * neuron_unit, struct ga_server_config * mut);
extern void * mutate_neuron_array(int num_neuron, int num_add_neuron, struct neuron ** 
											neuron_array, int * new_num_neuron);
extern int clean_char_buffer(char * char_buffer);
extern int read_neuron_array(int num_neuron, struct neuron ** neuron_array,	int fd);
extern int load_ga_server_config(struct ga_server_config *conf, const char * filename);
extern int get_fitness(int poblation, float base, float boost,  int * num_neuron, 
													double * error, float * fitness);
